#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(TLSServerContext)
    CONCEPT_FUNCTION(TLSClientContext)
    CONCEPT_FUNCTION(TLSAddCA)
    CONCEPT_FUNCTION(TLSSetCAFile)
    CONCEPT_FUNCTION(TLSTrust)
    CONCEPT_FUNCTION(TLSVerify)
    CONCEPT_FUNCTION(TLSTrustLocation)
    CONCEPT_FUNCTION(TLSCertificateFile)
    CONCEPT_FUNCTION(TLSPrivateKeyFile)
    CONCEPT_FUNCTION(TLSCertificate)
    CONCEPT_FUNCTION(TLSPrivateKey)
    CONCEPT_FUNCTION(TLSCertificate)
    CONCEPT_FUNCTION(TLSPrivateKey)
    CONCEPT_FUNCTION(TLSSet)
    CONCEPT_FUNCTION(TLSAccept)
    CONCEPT_FUNCTION(TLSConnect)
    CONCEPT_FUNCTION(TLSPending)
    CONCEPT_FUNCTION(TLSDone)
    CONCEPT_FUNCTION(TLSWrite)
    CONCEPT_FUNCTION(TLSRead)
    CONCEPT_FUNCTION(TLSError)
    CONCEPT_FUNCTION(TLSCheck)
    CONCEPT_FUNCTION(TLSCertificateInfo)
}

#endif // __LIBRARY_H
